diff -Nru libica-3.9.0/src/include/icastats.h libica-4.0.0/src/include/icastats.h
--- libica-3.9.0/src/include/icastats.h	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/include/icastats.h	2021-12-06 12:01:54.000000000 +0100
@@ -16,6 +16,9 @@
 
 #include <stdint.h>
 
+#include <openssl/obj_mac.h>
+
+#include "ica_api.h"
 
 typedef struct crypt_opts{
 	uint64_t hw;
@@ -47,9 +50,41 @@
 	ICA_STATS_PRNG,
 	ICA_STATS_DRBGSHA512,
 	ICA_STATS_ECDH,
+	ICA_STATS_ECDH_160,
+	ICA_STATS_ECDH_192,
+	ICA_STATS_ECDH_224,
+	ICA_STATS_ECDH_256,
+	ICA_STATS_ECDH_320,
+	ICA_STATS_ECDH_384,
+	ICA_STATS_ECDH_512,
+	ICA_STATS_ECDH_521,
 	ICA_STATS_ECDSA_SIGN,
+	ICA_STATS_ECDSA_SIGN_160,
+	ICA_STATS_ECDSA_SIGN_192,
+	ICA_STATS_ECDSA_SIGN_224,
+	ICA_STATS_ECDSA_SIGN_256,
+	ICA_STATS_ECDSA_SIGN_320,
+	ICA_STATS_ECDSA_SIGN_384,
+	ICA_STATS_ECDSA_SIGN_512,
+	ICA_STATS_ECDSA_SIGN_521,
 	ICA_STATS_ECDSA_VERIFY,
+	ICA_STATS_ECDSA_VERIFY_160,
+	ICA_STATS_ECDSA_VERIFY_192,
+	ICA_STATS_ECDSA_VERIFY_224,
+	ICA_STATS_ECDSA_VERIFY_256,
+	ICA_STATS_ECDSA_VERIFY_320,
+	ICA_STATS_ECDSA_VERIFY_384,
+	ICA_STATS_ECDSA_VERIFY_512,
+	ICA_STATS_ECDSA_VERIFY_521,
 	ICA_STATS_ECKGEN,
+	ICA_STATS_ECKGEN_160,
+	ICA_STATS_ECKGEN_192,
+	ICA_STATS_ECKGEN_224,
+	ICA_STATS_ECKGEN_256,
+	ICA_STATS_ECKGEN_320,
+	ICA_STATS_ECKGEN_384,
+	ICA_STATS_ECKGEN_512,
+	ICA_STATS_ECKGEN_521,
 	ICA_STATS_ED25519_KEYGEN,
 	ICA_STATS_ED25519_SIGN,
 	ICA_STATS_ED25519_VERIFY,
@@ -61,7 +96,15 @@
 	ICA_STATS_X448_KEYGEN,
 	ICA_STATS_X448_DERIVE,
 	ICA_STATS_RSA_ME,
-	ICA_STATS_RSA_CRT, /* add new crypt counters above RSA_CRT
+	ICA_STATS_RSA_ME_512,
+	ICA_STATS_RSA_ME_1024,
+	ICA_STATS_RSA_ME_2048,
+	ICA_STATS_RSA_ME_4096,
+	ICA_STATS_RSA_CRT,
+	ICA_STATS_RSA_CRT_512,
+	ICA_STATS_RSA_CRT_1024,
+	ICA_STATS_RSA_CRT_2048,
+	ICA_STATS_RSA_CRT_4096, /* add new crypt counters above RSA_CRT_4096
 			      (see print_stats function) */
 
 	/* enc and dec counter  */
@@ -78,13 +121,36 @@
 	ICA_STATS_3DES_CTR,
 	ICA_STATS_3DES_CMAC,
 	ICA_STATS_AES_ECB,
+	ICA_STATS_AES_ECB_128,
+	ICA_STATS_AES_ECB_192,
+	ICA_STATS_AES_ECB_256,
 	ICA_STATS_AES_CBC,
+	ICA_STATS_AES_CBC_128,
+	ICA_STATS_AES_CBC_192,
+	ICA_STATS_AES_CBC_256,
 	ICA_STATS_AES_OFB,
+	ICA_STATS_AES_OFB_128,
+	ICA_STATS_AES_OFB_192,
+	ICA_STATS_AES_OFB_256,
 	ICA_STATS_AES_CFB,
+	ICA_STATS_AES_CFB_128,
+	ICA_STATS_AES_CFB_192,
+	ICA_STATS_AES_CFB_256,
 	ICA_STATS_AES_CTR,
+	ICA_STATS_AES_CTR_128,
+	ICA_STATS_AES_CTR_192,
+	ICA_STATS_AES_CTR_256,
 	ICA_STATS_AES_CMAC,
+	ICA_STATS_AES_CMAC_128,
+	ICA_STATS_AES_CMAC_192,
+	ICA_STATS_AES_CMAC_256,
 	ICA_STATS_AES_XTS,
+	ICA_STATS_AES_XTS_128,
+	ICA_STATS_AES_XTS_256,
 	ICA_STATS_AES_GCM,
+	ICA_STATS_AES_GCM_128,
+	ICA_STATS_AES_GCM_192,
+	ICA_STATS_AES_GCM_256,
 
 	/* number of counters */
 	ICA_NUM_STATS
@@ -107,10 +173,42 @@
 	"GHASH",      	\
 	"P_RNG",      	\
 	"DRBG-SHA-512",	\
-	"ECDH",         \
-	"ECDSA Sign",   \
-	"ECDSA Verify", \
-	"EC Keygen",    \
+	"ECDH",		\
+	"- 160",	\
+	"- 192",	\
+	"- 224",	\
+	"- 256",	\
+	"- 320",	\
+	"- 384",	\
+	"- 512",	\
+	"- 521",	\
+	"ECDSA Sign",	\
+	"- 160",	\
+	"- 192",	\
+	"- 224",	\
+	"- 256",	\
+	"- 320",	\
+	"- 384",	\
+	"- 512",	\
+	"- 521",	\
+	"ECDSA Verify",	\
+	"- 160",	\
+	"- 192",	\
+	"- 224",	\
+	"- 256",	\
+	"- 320",	\
+	"- 384",	\
+	"- 512",	\
+	"- 521",	\
+	"EC Keygen",	\
+	"- 160",	\
+	"- 192",	\
+	"- 224",	\
+	"- 256",	\
+	"- 320",	\
+	"- 384",	\
+	"- 512",	\
+	"- 521",	\
 	"Ed25519 Keygen",\
 	"Ed25519 Sign", \
 	"Ed25519 Verify",\
@@ -121,8 +219,16 @@
 	"X25519 Derive",\
 	"X448 Keygen",  \
 	"X448 Derive",  \
-	"RSA-ME",     	\
-	"RSA-CRT",    	\
+	"RSA-ME",	\
+	"- 512",	\
+	"- 1024",	\
+	"- 2048",	\
+	"- 4096",	\
+	"RSA-CRT",	\
+	"- 512",	\
+	"- 1024",	\
+	"- 2048",	\
+	"- 4096",	\
 	"DES ECB",    	\
 	"DES CBC",    	\
 	"DES OFB",    	\
@@ -136,15 +242,36 @@
 	"3DES CTR",   	\
 	"3DES CMAC",	\
 	"AES ECB",	\
+	"- 128",	\
+	"- 192",	\
+	"- 256",	\
 	"AES CBC",	\
+	"- 128",	\
+	"- 192",	\
+	"- 256",	\
 	"AES OFB",	\
+	"- 128",	\
+	"- 192",	\
+	"- 256",	\
 	"AES CFB",	\
+	"- 128",	\
+	"- 192",	\
+	"- 256",	\
 	"AES CTR",	\
+	"- 128",	\
+	"- 192",	\
+	"- 256",	\
 	"AES CMAC",	\
-	"AES XTS",  \
-	"AES GCM"
-
-
+	"- 128",	\
+	"- 192",	\
+	"- 256",	\
+	"AES XTS",	\
+	"- 128",	\
+	"- 256",	\
+	"AES GCM",	\
+	"- 128",	\
+	"- 192",	\
+	"- 256"
 
 #define STATS_SHM_SIZE (sizeof(stats_entry_t) * ICA_NUM_STATS)
 #define ENCRYPT 1
@@ -167,5 +294,64 @@
 void stats_reset();
 int delete_all();
 
+static inline int aes_directed_fc_stats_ofs(unsigned int fc)
+{
+	switch (fc) {
+	case AES_128_DECRYPT:
+	case AES_128_ENCRYPT:
+		return 0;
+	case AES_192_DECRYPT:
+	case AES_192_ENCRYPT:
+		return 1;
+	case AES_256_DECRYPT:
+	case AES_256_ENCRYPT:
+		return 2;
+	case AES_128_XTS_ENCRYPT:
+	case AES_128_XTS_DECRYPT:
+		return 0;
+	case AES_256_XTS_ENCRYPT:
+	case AES_256_XTS_DECRYPT:
+		return 1;
+	}
+	return 0;
+}
+
+static inline int rsa_keysize_stats_ofs(unsigned int key_length)
+{
+	if (key_length >= 4096 / 8)
+		return 3;
+	if (key_length >= 2048 / 8)
+		return 2;
+	if (key_length >= 1024 / 8)
+		return 1;
+	return 0;
+}
+
+static inline int ecc_keysize_stats_ofs(int nid)
+{
+	switch (nid) {
+	case NID_brainpoolP160r1:
+		return 0;
+	case NID_X9_62_prime192v1:
+	case NID_brainpoolP192r1:
+		return 1;
+	case NID_secp224r1:
+	case NID_brainpoolP224r1:
+		return 2;
+	case NID_X9_62_prime256v1:
+	case NID_brainpoolP256r1:
+		return 3;
+	case NID_brainpoolP320r1:
+		return 4;
+	case NID_secp384r1:
+	case NID_brainpoolP384r1:
+		return 5;
+	case NID_brainpoolP512r1:
+		return 6;
+	case NID_secp521r1:
+		return 7;
+	}
+	return 0;
+}
 
 #endif
diff -Nru libica-3.9.0/src/include/s390_aes.h libica-4.0.0/src/include/s390_aes.h
--- libica-3.9.0/src/include/s390_aes.h	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/include/s390_aes.h	2021-12-06 12:01:54.000000000 +0100
@@ -140,7 +140,7 @@
 	if (rc)
 		return rc;
 
-	stats_increment(ICA_STATS_AES_GCM,
+	stats_increment(ICA_STATS_AES_GCM_128 + aes_directed_fc_stats_ofs(fc),
 			ALGO_HW,
 			(s390_kma_functions[fc].hw_fc &
 			S390_CRYPTO_DIRECTION_MASK) == 0 ?
@@ -164,7 +164,8 @@
 	if (rc)
 		return rc;
 
-	stats_increment(ICA_STATS_AES_CTR, ALGO_HW,
+	stats_increment(ICA_STATS_AES_CTR_128 + aes_directed_fc_stats_ofs(fc),
+			ALGO_HW,
 			 (s390_msa4_functions[fc].hw_fc &
 			 S390_CRYPTO_DIRECTION_MASK) ==
 			 0 ?ENCRYPT:DECRYPT);
@@ -426,7 +427,8 @@
 				     out_data);
 		hardware = ALGO_SW;
 	}
-	stats_increment(ICA_STATS_AES_ECB,
+
+	stats_increment(ICA_STATS_AES_ECB_128 + aes_directed_fc_stats_ofs(fc),
 			hardware,
 			(s390_kmc_functions[fc].hw_fc &
 			S390_CRYPTO_DIRECTION_MASK) == 0 ?
@@ -453,7 +455,8 @@
 				     out_data);
 		hardware = ALGO_SW;
 	}
-	stats_increment(ICA_STATS_AES_CBC,
+
+	stats_increment(ICA_STATS_AES_CBC_128 + aes_directed_fc_stats_ofs(fc),
 			hardware, (s390_kmc_functions[fc].hw_fc &
 			S390_CRYPTO_DIRECTION_MASK) == 0 ?
 			ENCRYPT:DECRYPT);
@@ -506,7 +509,8 @@
 	if (rc)
 		return rc;
 
-	stats_increment(ICA_STATS_AES_CFB, ALGO_HW,
+	stats_increment(ICA_STATS_AES_CFB_128 + aes_directed_fc_stats_ofs(fc),
+			ALGO_HW,
 			(s390_kmc_functions[fc].hw_fc &
 			S390_CRYPTO_DIRECTION_MASK) == 0 ?
 			ENCRYPT:DECRYPT);
@@ -599,7 +603,8 @@
 	if (rc)
 		return rc;
 
-	stats_increment(ICA_STATS_AES_OFB, ALGO_HW,
+	stats_increment(ICA_STATS_AES_OFB_128 + aes_directed_fc_stats_ofs(fc),
+			ALGO_HW,
 			(s390_kmc_functions[fc].hw_fc &
 			S390_CRYPTO_DIRECTION_MASK) == 0 ?
 			ENCRYPT:DECRYPT);
@@ -844,7 +849,8 @@
 	if (rc)
 		return rc;
 
-	stats_increment(ICA_STATS_AES_XTS, ALGO_HW,
+	stats_increment(ICA_STATS_AES_XTS_128 + aes_directed_fc_stats_ofs(fc),
+			ALGO_HW,
 			(s390_kmc_functions[fc].hw_fc &
 			S390_CRYPTO_DIRECTION_MASK) == 0 ?
 			ENCRYPT:DECRYPT);
diff -Nru libica-3.9.0/src/include/s390_cmac.h libica-4.0.0/src/include/s390_cmac.h
--- libica-3.9.0/src/include/s390_cmac.h	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/include/s390_cmac.h	2021-12-06 12:01:54.000000000 +0100
@@ -90,7 +90,9 @@
 		case 26:
 		case 27:
 		case 28:
-			stats_increment(ICA_STATS_AES_CMAC, hw, direction);
+			stats_increment(ICA_STATS_AES_CMAC_128 +
+					aes_directed_fc_stats_ofs(fc),
+					hw, direction);
 			break;
 		default:
 			break;
diff -Nru libica-3.9.0/src/include/s390_crypto.h libica-4.0.0/src/include/s390_crypto.h
--- libica-3.9.0/src/include/s390_crypto.h	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/include/s390_crypto.h	2021-12-06 12:01:54.000000000 +0100
@@ -25,6 +25,11 @@
 
 #include <openssl/opensslv.h>
 
+/* major 4.0: no more exported, now internal */
+int s390_initialize_functionlist(void);
+int s390_get_functionlist(libica_func_list_element *pmech_list,
+			  unsigned int *pmech_list_len);
+
 #ifndef OPENSSL_VERSION_PREREQ
     #if defined(OPENSSL_VERSION_MAJOR) && defined(OPENSSL_VERSION_MINOR)
         #define OPENSSL_VERSION_PREREQ(maj, min)        \
diff -Nru libica-3.9.0/src/include/s390_gcm.h libica-4.0.0/src/include/s390_gcm.h
--- libica-3.9.0/src/include/s390_gcm.h	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/include/s390_gcm.h	2021-12-06 12:01:54.000000000 +0100
@@ -745,9 +745,13 @@
 	if (rc >= 0) {
 		ctx->subkey_provided = 1;
 		if (ctx->direction)
-			stats_increment(ICA_STATS_AES_GCM, ALGO_HW, ENCRYPT);
+			stats_increment(ICA_STATS_AES_GCM_128 +
+					aes_directed_fc_stats_ofs(function_code),
+					ALGO_HW, ENCRYPT);
 		else
-			stats_increment(ICA_STATS_AES_GCM, ALGO_HW, DECRYPT);
+			stats_increment(ICA_STATS_AES_GCM_128 +
+					aes_directed_fc_stats_ofs(function_code),
+					ALGO_HW, DECRYPT);
 		return 0;
 	} else
 		return EIO;
diff -Nru libica-3.9.0/src/include/s390_sha.h libica-4.0.0/src/include/s390_sha.h
--- libica-3.9.0/src/include/s390_sha.h	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/include/s390_sha.h	2021-12-06 12:01:54.000000000 +0100
@@ -104,67 +104,67 @@
 	{S390_CRYPTO_SHA_512, 32, 64, 128, SHA_512_256_DEFAULT_IV},
 };
 
-int s390_sha1(unsigned char *iv, unsigned char *input_data,
+int s390_sha1(unsigned char *iv, const unsigned char *input_data,
 	      unsigned int input_length, unsigned char *output_data,
 	      unsigned int message_part, uint64_t *running_length);
 
-int s390_sha224(unsigned char *iv, unsigned char *input_data,
+int s390_sha224(unsigned char *iv, const unsigned char *input_data,
 		unsigned int input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length);
 
-int s390_sha256(unsigned char *iv, unsigned char *input_data,
+int s390_sha256(unsigned char *iv, const unsigned char *input_data,
 		unsigned int input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length);
 
-int s390_sha384(unsigned char *iv, unsigned char *input_data,
+int s390_sha384(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi);
 
-int s390_sha512(unsigned char *iv, unsigned char *input_data,
+int s390_sha512(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi);
 
-int s390_sha512_224(unsigned char *iv, unsigned char *input_data,
+int s390_sha512_224(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi);
 
-int s390_sha512_256(unsigned char *iv, unsigned char *input_data,
+int s390_sha512_256(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi);
 
-int s390_sha3_224(unsigned char *iv, unsigned char *input_data,
+int s390_sha3_224(unsigned char *iv, const unsigned char *input_data,
 		unsigned int input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length);
 
-int s390_sha3_256(unsigned char *iv, unsigned char *input_data,
+int s390_sha3_256(unsigned char *iv, const unsigned char *input_data,
 		unsigned int input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length);
 
-int s390_sha3_384(unsigned char *iv, unsigned char *input_data,
+int s390_sha3_384(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi);
 
-int s390_sha3_512(unsigned char *iv, unsigned char *input_data,
+int s390_sha3_512(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi);
 
-int s390_shake_128(unsigned char *iv, unsigned char *input_data,
+int s390_shake_128(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data, unsigned int output_length,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi);
 
-int s390_shake_256(unsigned char *iv, unsigned char *input_data,
+int s390_shake_256(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data, unsigned int output_length,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi);
 
-int s390_shake_hw(unsigned char *iv, unsigned char *input_data,
+int s390_shake_hw(unsigned char *iv, const unsigned char *input_data,
 		       uint64_t input_length, unsigned char *output_data, unsigned int output_length,
 		       unsigned int message_part, uint64_t *running_length_lo,
 		       uint64_t *running_length_hi, kimd_functions_t sha_function);
@@ -179,7 +179,7 @@
 	return (n >= SHA_3_224 && n <= SHA_3_512 ? 1 : 0);
 }
 
-static inline int s390_sha_hw(unsigned char *iv, unsigned char *input_data,
+static inline int s390_sha_hw(unsigned char *iv, const unsigned char *input_data,
 		       uint64_t input_length, unsigned char *output_data, unsigned int output_length,
 		       unsigned int message_part, uint64_t *running_length_lo,
 		       uint64_t *running_length_hi, kimd_functions_t sha_function)
diff -Nru libica-3.9.0/src/Makefile.am libica-4.0.0/src/Makefile.am
--- libica-3.9.0/src/Makefile.am	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/Makefile.am	2021-12-06 12:01:54.000000000 +0100
@@ -1,4 +1,4 @@
-VERSION = 3:9:0
+VERSION = 4:0:0
 
 AM_CFLAGS = @FLAGS@
 MAJOR := `echo $(VERSION) | cut -d: -f1`
@@ -10,7 +10,7 @@
 
 lib_LTLIBRARIES = libica.la libica-cex.la
 
-CFLAGS_common = ${AM_CFLAGS} -I${srcdir}/include -I${srcdir}/../include \
+CFLAGS_common = ${AM_CFLAGS} -DNO_SW_FALLBACKS -I${srcdir}/include -I${srcdir}/../include \
 		   -DLIBICA_CONFDIR=\"${sysconfdir}\" \
 		   -fvisibility=hidden -pthread
 LIBS_common = @LIBS@ -lrt -lcrypto -ldl
@@ -36,7 +36,7 @@
 libica_la_LDFLAGS = ${LDFLAGS_common}
 libica_la_SOURCES = ${SOURCES_common}
 
-libica_cex_la_CFLAGS = ${CFLAGS_common} -DNO_CPACF -DNO_SW_FALLBACKS -DLIBNAME=\"libica-cex\"
+libica_cex_la_CFLAGS = ${CFLAGS_common} -DNO_CPACF -DLIBNAME=\"libica-cex\"
 libica_cex_la_CCASFLAGS = ${AM_CFLAGS}
 libica_cex_la_LIBADD = ${LIBS_common}
 libica_cex_la_LDFLAGS = ${LDFLAGS_common}
@@ -64,7 +64,7 @@
 
 bin_PROGRAMS = icainfo icastats icainfo-cex
 
-icainfo_CFLAGS_COMMON = ${AM_CFLAGS} -I${srcdir}/include -I${srcdir}/../include
+icainfo_CFLAGS_COMMON = ${AM_CFLAGS} -DNO_SW_FALLBACKS -I${srcdir}/include -I${srcdir}/../include
 icainfo_LDADD_COMMON = @LIBS@ -lcrypto
 icainfo_SOURCES_COMMON = icainfo.c include/fips.h include/s390_crypto.h \
 		  ../include/ica_api.h
@@ -73,11 +73,11 @@
 icainfo_LDADD = ${icainfo_LDADD_COMMON} libica.la
 icainfo_SOURCES = ${icainfo_SOURCES_COMMON}
 
-icainfo_cex_CFLAGS = ${icainfo_CFLAGS_COMMON} -DNO_CPACF -DNO_SW_FALLBACKS
+icainfo_cex_CFLAGS = ${icainfo_CFLAGS_COMMON} -DNO_CPACF
 icainfo_cex_LDADD = ${icainfo_LDADD_COMMON} libica-cex.la
 icainfo_cex_SOURCES = ${icainfo_SOURCES_COMMON}
 
-icastats_CFLAGS = ${AM_CFLAGS} -I${srcdir}/include -DICASTATS
+icastats_CFLAGS = ${AM_CFLAGS} -I${srcdir}/include -I${srcdir}/../include -DICASTATS
 icastats_LDADD = @LIBS@ -lrt
 icastats_SOURCES = icastats.c icastats_shared.c include/icastats.h
 
diff -Nru libica-3.9.0/src/s390_crypto.c libica-4.0.0/src/s390_crypto.c
--- libica-3.9.0/src/s390_crypto.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/s390_crypto.c	2021-12-06 12:01:54.000000000 +0100
@@ -680,14 +680,20 @@
 #ifdef NO_CPACF
 	pmech_list[x].flags &= ~ICA_FLAG_SHW;
 	/* NO_CPACF also removes sw fallbacks for CPACF based functions, but not
-	 * for card-based functions. */
-	if (pmech_list[x].flags & ICA_FLAG_SW && !(pmech_list[x].flags & ICA_FLAG_DHW)) {
+	 * for card-based functions and RSA keygen, which is only available in sw. */
+	if (pmech_list[x].flags & ICA_FLAG_SW && !(pmech_list[x].flags & ICA_FLAG_DHW) &&
+		pmech_list[x].mech_mode_id != RSA_KEY_GEN_ME &&
+		pmech_list[x].mech_mode_id != RSA_KEY_GEN_CRT) {
 		pmech_list[x].flags &= ~ICA_FLAG_SW;
 	}
 #endif /* NO_CPACF */
 
 #ifdef NO_SW_FALLBACKS
-	pmech_list[x].flags &= ~ICA_FLAG_SW;
+	/* Set SW flag to 0 if we don't have sw fallbacks, except for RSA keygen,
+	 * because there is no hw path for RSA keygen. */
+	if (pmech_list[x].mech_mode_id != RSA_KEY_GEN_ME &&
+		pmech_list[x].mech_mode_id != RSA_KEY_GEN_CRT)
+		pmech_list[x].flags &= ~ICA_FLAG_SW;
 #endif
   }
   return 0;
diff -Nru libica-3.9.0/src/s390_rsa.c libica-4.0.0/src/s390_rsa.c
--- libica-3.9.0/src/s390_rsa.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/s390_rsa.c	2021-12-06 12:01:54.000000000 +0100
@@ -42,24 +42,24 @@
 #endif
 
 #ifndef NO_SW_FALLBACKS
-static unsigned int mod_expo_sw(int arg_length, char *arg, int exp_length,
-				char *exp, int mod_length, char *mod,
-				int *res_length, char *res, BN_CTX *ctx);
-static unsigned int mod_mul_sw(int fc_1_length, char *fc1, int fc_2_length,
-			      char *fc2, int mod_length, char *mod,
-			      int *res_length, char *res, BN_CTX *ctx);
-static unsigned int mod_sw(int arg_length, char *arg, int mod_length,
-			   char *mod, int *res_length, char *res, BN_CTX *ctx);
-static unsigned int add_sw(int aug_length, char *aug, int add_length,
-			   char *add, int *res_length, char *res, BN_CTX *ctx);
-static unsigned int mod_sub_sw(int min_length, char *minu, int sub_length,
-			       char *sub, int mod_length, char *mod,
-			       int *res_length, char *res, BN_CTX * ctx);
-static unsigned int mul_sw(int fc_1_length, char *fc1, int fc_2_length,
-			   char *fc2, int *res_length, char *res, BN_CTX *ctx);
-static unsigned int mod_expo_sw(int arg_length, char *arg, int exp_length,
-				char *exp, int mod_length, char *mod,
-				int *res_length, char *res, BN_CTX *ctx);
+static unsigned int mod_expo_sw(int arg_length, unsigned char *arg, int exp_length,
+				unsigned char *exp, int mod_length, unsigned char *mod,
+				int *res_length, unsigned char *res, BN_CTX *ctx);
+static unsigned int mod_mul_sw(int fc_1_length, unsigned char *fc1, int fc_2_length,
+			      unsigned char *fc2, int mod_length, unsigned char *mod,
+			      int *res_length, unsigned char *res, BN_CTX *ctx);
+static unsigned int mod_sw(int arg_length, unsigned char *arg, int mod_length,
+			   unsigned char *mod, int *res_length, unsigned char *res, BN_CTX *ctx);
+static unsigned int add_sw(int aug_length, unsigned char *aug, int add_length,
+			   unsigned char *add, int *res_length, unsigned char *res, BN_CTX *ctx);
+static unsigned int mod_sub_sw(int min_length, unsigned char *minu, int sub_length,
+			       unsigned char *sub, int mod_length, unsigned char *mod,
+			       int *res_length, unsigned char *res, BN_CTX * ctx);
+static unsigned int mul_sw(int fc_1_length, unsigned char *fc1, int fc_2_length,
+			   unsigned char *fc2, int *res_length, unsigned char *res, BN_CTX *ctx);
+static unsigned int mod_expo_sw(int arg_length, unsigned char *arg, int exp_length,
+				unsigned char *exp, int mod_length, unsigned char *mod,
+				int *res_length, unsigned char *res, BN_CTX *ctx);
 #endif /* NO_SW_FALLBACKS */
 
 #if !OPENSSL_VERSION_PREREQ(3, 0)
@@ -450,9 +450,9 @@
  * Perform a multiprecision modular multiplication using a multiplicand,
  * multiplier and modulus.
  */
-static unsigned int mod_mul_sw(int fc_1_length, char *fc1, int fc_2_length,
-			      char *fc2, int mod_length, char *mod,
-			      int *res_length, char *res, BN_CTX *ctx)
+static unsigned int mod_mul_sw(int fc_1_length, unsigned char *fc1, int fc_2_length,
+			      unsigned char *fc2, int mod_length, unsigned char *mod,
+			      int *res_length, unsigned char *res, BN_CTX *ctx)
 {
 	int rc = 0;
 	int ln = 0;
@@ -587,9 +587,9 @@
  *
  * Returns 0 if successful BN error code if unsuccessful.
  */
-static unsigned int mod_expo_sw(int arg_length, char *arg, int exp_length,
-				char *exp, int mod_length, char *mod,
-				int *res_length, char *res, BN_CTX *ctx)
+static unsigned int mod_expo_sw(int arg_length, unsigned char *arg, int exp_length,
+				unsigned char *exp, int mod_length, unsigned char *mod,
+				int *res_length, unsigned char *res, BN_CTX *ctx)
 {
 	int rc = 0;
 	int ln = 0;
@@ -700,11 +700,11 @@
 	size for ir buffers. Thus the software fallback should be able to
 	handle keys of bigger size, too.
 */
-	char ir1[long_length];
+	unsigned char ir1[long_length];
 	int ir_1_length = sizeof(ir1);
-	char ir2[long_length];
+	unsigned char ir2[long_length];
 	int ir_2_length = sizeof(ir2);
-	char temp[long_length];
+	unsigned char temp[long_length];
 	int temp_length = sizeof(temp);
 
 	if ((ctx = BN_CTX_new()) == NULL) {
@@ -825,8 +825,8 @@
  *
  * Returns 0 if successful, BN error code if unsuccessful
  */
-static unsigned int mod_sw(int arg_length, char *arg, int mod_length,
-			   char *mod, int *res_length, char *res, BN_CTX *ctx)
+static unsigned int mod_sw(int arg_length, unsigned char *arg, int mod_length,
+			   unsigned char *mod, int *res_length, unsigned char *res, BN_CTX *ctx)
 {
 	int rc = 0;
 	int ln = 0;
@@ -906,9 +906,9 @@
  * 5) Convert the result from a BN to a string using BN_bn2bin
  * 6) Call BN_free for the minuend, subtrahend and result BN's
  */
-static unsigned int mod_sub_sw(int min_length, char *minu, int sub_length,
-			       char *sub, int mod_length, char *mod,
-			       int *res_length, char *res, BN_CTX * ctx)
+static unsigned int mod_sub_sw(int min_length, unsigned char *minu, int sub_length,
+			       unsigned char *sub, int mod_length, unsigned char *mod,
+			       int *res_length, unsigned char *res, BN_CTX * ctx)
 {
 	int rc = 0;
 	int ln = 0;
@@ -1010,8 +1010,8 @@
  * 4) Convert the result from a BN to a string using BN_bn2bin
  * 5) Call BN_free for the augend, addend and result BN's
 */
-static unsigned int add_sw(int aug_length, char *aug, int add_length,
-			   char *add, int *res_length, char *res, BN_CTX *ctx)
+static unsigned int add_sw(int aug_length, unsigned char *aug, int add_length,
+			   unsigned char *add, int *res_length, unsigned char *res, BN_CTX *ctx)
 {
 	int rc = 0;
 	int ln = 0;
@@ -1079,8 +1079,8 @@
  *
  * Returns 0 if successful, BN error code if unsuccessful
  */
-static unsigned int mul_sw(int fc_1_length, char *fc1, int fc_2_length,
-			   char *fc2, int *res_length, char *res, BN_CTX *ctx)
+static unsigned int mul_sw(int fc_1_length, unsigned char *fc1, int fc_2_length,
+			   unsigned char *fc2, int *res_length, unsigned char *res, BN_CTX *ctx)
 {
 	int rc = 0;
 	int ln = 0;
diff -Nru libica-3.9.0/src/s390_sha.c libica-4.0.0/src/s390_sha.c
--- libica-3.9.0/src/s390_sha.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/s390_sha.c	2021-12-06 12:01:54.000000000 +0100
@@ -28,7 +28,7 @@
 #include "init.h"
 #include "icastats.h"
 
-int s390_sha1(unsigned char *iv, unsigned char *input_data,
+int s390_sha1(unsigned char *iv, const unsigned char *input_data,
 	      unsigned int input_length, unsigned char *output_data,
 	      unsigned int message_part, uint64_t *running_length)
 {
@@ -44,7 +44,7 @@
 	return rc;
 }
 
-int s390_sha224(unsigned char *iv, unsigned char *input_data,
+int s390_sha224(unsigned char *iv, const unsigned char *input_data,
 		unsigned int input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length)
 {
@@ -60,7 +60,7 @@
 	return rc;
 }
 
-int s390_sha256(unsigned char *iv, unsigned char *input_data,
+int s390_sha256(unsigned char *iv, const unsigned char *input_data,
 		unsigned int input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length)
 {
@@ -75,7 +75,7 @@
 
 	return rc;
 }
-int s390_sha384(unsigned char *iv, unsigned char *input_data,
+int s390_sha384(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi)
@@ -93,7 +93,7 @@
 	return rc;
 }
 
-int s390_sha512(unsigned char *iv, unsigned char *input_data,
+int s390_sha512(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi)
@@ -111,7 +111,7 @@
 	return rc;
 }
 
-int s390_sha512_224(unsigned char *iv, unsigned char *input_data,
+int s390_sha512_224(unsigned char *iv, const unsigned char *input_data,
 		    uint64_t input_length, unsigned char *output_data,
 		    unsigned int message_part, uint64_t *running_length_lo,
 		    uint64_t *running_length_hi)
@@ -129,7 +129,7 @@
 	return rc;
 }
 
-int s390_sha512_256(unsigned char *iv, unsigned char *input_data,
+int s390_sha512_256(unsigned char *iv, const unsigned char *input_data,
 		    uint64_t input_length, unsigned char *output_data,
 		    unsigned int message_part, uint64_t *running_length_lo,
 		    uint64_t *running_length_hi)
@@ -147,7 +147,7 @@
 	return rc;
 }
 
-int s390_sha3_224(unsigned char *iv, unsigned char *input_data,
+int s390_sha3_224(unsigned char *iv, const unsigned char *input_data,
 		unsigned int input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length)
 {
@@ -163,7 +163,7 @@
 	return rc;
 }
 
-int s390_sha3_256(unsigned char *iv, unsigned char *input_data,
+int s390_sha3_256(unsigned char *iv, const unsigned char *input_data,
 		unsigned int input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length)
 {
@@ -179,7 +179,7 @@
 	return rc;
 }
 
-int s390_sha3_384(unsigned char *iv, unsigned char *input_data,
+int s390_sha3_384(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi)
@@ -197,7 +197,7 @@
 	return rc;
 }
 
-int s390_sha3_512(unsigned char *iv, unsigned char *input_data,
+int s390_sha3_512(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi)
@@ -215,7 +215,7 @@
 	return rc;
 }
 
-int s390_shake_128(unsigned char *iv, unsigned char *input_data,
+int s390_shake_128(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data, unsigned int output_length,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi)
@@ -232,7 +232,7 @@
 	return rc;
 }
 
-int s390_shake_256(unsigned char *iv, unsigned char *input_data,
+int s390_shake_256(unsigned char *iv, const unsigned char *input_data,
 		uint64_t input_length, unsigned char *output_data, unsigned int output_length,
 		unsigned int message_part, uint64_t *running_length_lo,
 		uint64_t *running_length_hi)
diff -Nru libica-3.9.0/test/get_functionlist_cex_test.c libica-4.0.0/test/get_functionlist_cex_test.c
--- libica-3.9.0/test/get_functionlist_cex_test.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/test/get_functionlist_cex_test.c	2021-12-06 12:01:54.000000000 +0100
@@ -23,11 +23,14 @@
  * For libica-cex, all CPACF-related functions and software fallbacks are
  * unavailable. Only RSA-ME, RSA-CRT, ECDH, ECDSA, and EC keygen may be
  * available via a CCA card. As we don't check for a CCA card here, just
- * skip these.
+ * skip these. Also RSA keygen is an exception: it's no sw fallback, but
+ * a sw implementation.
  */
 int cex_check_ok(libica_func_list_element func)
 {
 	switch (func.mech_mode_id) {
+	case RSA_KEY_GEN_ME:
+	case RSA_KEY_GEN_CRT:
 	case RSA_ME:
 	case RSA_CRT:
 	case EC_DH:
@@ -64,6 +67,12 @@
 	V_(printf("Retrieved number of elements: %d\n", count));
 
 	libica_func_list = malloc(sizeof(libica_func_list_element) * count);
+	if (!libica_func_list) {
+		V_(printf("Cannot malloc libica_func_list\n"));
+		failed++;
+		goto done;
+	}
+
 	rc = ica_get_functionlist(libica_func_list, &count);
 	if (rc) {
 		V_(printf("Retrieving function list for libica-cex failed with rc=%02x\n", rc));
@@ -88,6 +97,9 @@
 		failed++;
 	}
 
+done:
+	free(libica_func_list);
+
 	if (failed) {
 		printf("ica_get_functionlist tests for libica-cex failed.\n");
 		return TEST_FAIL;
diff -Nru libica-3.9.0/test/get_functionlist_test.c libica-4.0.0/test/get_functionlist_test.c
--- libica-3.9.0/test/get_functionlist_test.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/test/get_functionlist_test.c	2021-12-06 12:01:54.000000000 +0100
@@ -38,6 +38,12 @@
 	V_(printf("Retrieved number of elements: %d\n", count));
 
 	libica_func_list = malloc(sizeof(libica_func_list_element) * count);
+	if (!libica_func_list) {
+		V_(printf("Cannot malloc libica_func_list\n"));
+		failed++;
+		goto done;
+	}
+
 	rc = ica_get_functionlist(libica_func_list, &count);
 	if (rc) {
 		V_(printf("Retrieving function list failed with rc=%02x\n", rc));
@@ -58,6 +64,9 @@
 		failed++;
 	}
 
+done:
+	free(libica_func_list);
+
 	if (failed) {
 		printf("ica_get_functionlist tests failed.\n");
 		return TEST_FAIL;
